<?php
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2006 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/
/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on operating system
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: id of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoOS($table, $site,$toplot) {
  echoMonthly($table,$site,"os",$toplot);
}

/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on web browsers
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: id of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoBrowser($table, $site,$toplot) {
  echoMonthly($table,$site,"browser",$toplot);
}

/*********************************************************************************/
/* Function: echoOS
/* Role: stats results on operating systems
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: id of the website
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/
function echoCountry($table, $site,$toplot) {
  echoMonthly($table,$site,"country",$toplot);
}

/*********************************************************************************/
/* Function: browserImgName
/* Role: returns the logo and name of a browser 
/* Parameters: 
/*   - $c: browser name
/* Output:
/*   - string, with image link to the browser logo and its name
/* Created: 05/2005
/*********************************************************************************/
function browserImgName($c) {
	$img="Img/noimage.gif";
	$strings = array("msie", "firefox", "gecko", "konqueror", "safari", "ns", "opera", "crawler", "google", "lynx","galeon");
	$images = array("Img/ie.gif", "Img/firefox.gif", "Img/mozilla.gif", "Img/konqueror.gif", "Img/safari.gif", "Img/netscape.gif", "Img/opera.gif", "Img/crawler.gif", "Img/crawler.gif","Img/lynx.gif","Img/galeon.gif");
	for ($cpt = 0; $cpt < 11 ; $cpt++) {
		if (ereg($strings[$cpt],strtolower($c))) $img=$images[$cpt];
	}
	if(is_file($img)) {
		$string = "<center><img src=\"$img\" alt=\"$c\"></center></td><td>$c";
	} else {
		$string = "</td><td>$c";
	}
	return $string;
}

/*********************************************************************************/
/* Function: osImgName
/* Role: returns the logo and name of an OS
/* Parameters: 
/*   - $c: os name
/* Output:
/*   - string, with image link to the os logo and its name
/* Created: 05/2005
/*********************************************************************************/
function osImgName($c) {
	$img="Img/noimage.gif";
	$strings = array("win", "linux", "mac", "sun", "bsd", "sgi", "hp", "crawler", "google","palm");
	$images = array("Img/windows.gif", "Img/linux.gif", "Img/osx.gif", "Img/sun.gif", "Img/bsd.gif", "Img/sgi.gif", "Img/hp.gif", "Img/crawler.gif", "Img/crawler.gif","Img/palm.gif"); 
	for ($cpt = 0; $cpt < 10 ; $cpt++) {
		if (ereg($strings[$cpt],strtolower($c))) $img=$images[$cpt];
	}
	if(is_file($img)) {
		$string = "<center><img src=\"$img\" alt=\"$c\"></center></td><td>$c";
	} else {
		$string = "</td><td>$c";
	}
	return $string;
}


/*********************************************************************************/
/* Function: countryNameFlag
/* Role: converts the 2 chars string into full country name 
/*    and flag 
/* Parameters: 
/*   - $c: 2 chars country string
/* Output:
/*   - string, with image link to the flag and full country name
/* Source: ip2c, http://hot-things.net
/* Created: 06/2004
/* Changed 05/2005 (added </td><td> between the image and the country name)
/*********************************************************************************/
function countryNameFlag($c) {
  global $ip2c;
  global $extFlag;
  global $dirFlags;
  $ty=strtolower($c);
  $ty=str_replace("\n","",$ty);
  switch($ty){
    case'ac':$rz='Ascension Island';break;
    case'ad':$rz='Andorra';break;
    case'ae':$rz='United Arab Emirates';break;
    case'af':$rz='Afghanistan';break;
    case'ag':$rz='Antigua and Barbuda';break;
    case'ai':$rz='Anguilla';break;
    case'al':$rz='Albania';break;
    case'am':$rz='Armenia';break;
    case'an':$rz='Netherlands Antilles';break;
    case'ao':$rz='Angola';break;
    case'aq':$rz='Antarctica';break;
    case'ar':$rz='Argentina';break;
    case'as':$rz='American Samoa';break;
    case'at':$rz='Austria';break;
    case'au':$rz='Australia';break;
    case'aw':$rz='Aruba';break;
    case'az':$rz='Azerbaijan';break;
    case'ba':$rz='Bosnia and Herzegowina';break;
    case'bb':$rz='Barbados';break;
    case'bd':$rz='Bangladesh';break;
    case'be':$rz='Belgium';break;
    case'bf':$rz='Burkina Faso';break;
    case'bg':$rz='Bulgaria';break;
    case'bh':$rz='Bahrain';break;
    case'bi':$rz='Burundi';break;
    case'bj':$rz='Benin';break;
    case'bm':$rz='Bermuda';break;
    case'bn':$rz='Brunei Darussalam';break;
    case'bo':$rz='Bolivia';break;
    case'br':$rz='Brazil';break;
    case'bs':$rz='Bahamas';break;
    case'bt':$rz='Bhutan';break;
    case'bv':$rz='Bouvet Island';break;
    case'bw':$rz='Botswana';break;
    case'by':$rz='Belarus';break;
    case'bz':$rz='Belize';break;
    case'ca':$rz='Canada';break;
    case'cc':$rz='Cocos (Keeling) Islands';break;
    case'cd':$rz='Zaire';break;
    case'cf':$rz='Central African Republic';break;
    case'cg':$rz='Congo';break;
    case'ch':$rz='Switzerland';break;
    case'ci':$rz='Cote d\'Ivoire';break;
    case'ck':$rz='Cook Islands';break;
    case'cl':$rz='Chile';break;
    case'cm':$rz='Cameroon';break;
    case'cn':$rz='China';break;
    case'co':$rz='Colombia';break;
    case'cr':$rz='Costa Rica';break;
    case'cs':$rz='Czechoslovakia (former)';break;
    case'cu':$rz='Cuba';break;
    case'cv':$rz='Cape Verde';break;
    case'cx':$rz='Christmas Island';break;
    case'cy':$rz='Cyprus';break;
    case'cz':$rz='Czech Republic';break;
    case'de':$rz='Germany';break;
    case'dj':$rz='Djibouti';break;
    case'dk':$rz='Denmark';break;
    case'dm':$rz='Dominica';break;
    case'do':$rz='Dominican Republic';break;
    case'dz':$rz='Algeria';break;
    case'ec':$rz='Ecuador';break;
    case'ee':$rz='Estonia';break;
    case'eg':$rz='Egypt';break;
    case'eh':$rz='Western Sahara';break;
    case'er':$rz='Eritrea';break;
    case'es':$rz='Spain';break;
    case'et':$rz='Ethiopia';break;
    case'fi':$rz='Finland';break;
    case'fj':$rz='Fiji';break;
    case'fk':$rz='Falkland Islands';break;
    case'fm':$rz='Micronesia';break;
    case'fo':$rz='Faroe Islands';break;
    case'fr':$rz='France';break;
    case'fx':$rz='France, Metropolitan';break;
    case'ga':$rz='Gabon';break;
    case'gb':$rz='United Kingdom';break;
    case'gd':$rz='Grenada';break;
    case'ge':$rz='Georgia';break;
    case'gf':$rz='French Guiana';break;
    case'gg':$rz='Guernsey';break;
    case'gh':$rz='Ghana';break;
    case'gi':$rz='Gibraltar';break;
    case'gl':$rz='Greenland';break;
    case'gm':$rz='Gambia';break;
    case'gn':$rz='Guinea';break;
    case'gp':$rz='Guadelope';break;
    case'gq':$rz='Equatorial Guinea';break;
    case'gr':$rz='Greece';break;
    case'gs':$rz='Sth Georgia &Sth Sandwich Is.';break;
    case'gt':$rz='Guatemala';break;
    case'gu':$rz='Guam';break;
    case'gw':$rz='Guinea-Bissau';break;
    case'gy':$rz='Guyana';break;
    case'hk':$rz='Hong Kong';break;
    case'hm':$rz='Heard and McDonald Islands';break;
    case'hn':$rz='Honduras';break;
    case'hr':$rz='Croatia';break;
    case'ht':$rz='Haiti';break;
    case'hu':$rz='Hungary';break;
    case'id':$rz='Indonesia';break;
    case'ie':$rz='Ireland';break;
    case'il':$rz='Israel';break;
    case'im':$rz='Isle of Man';break;
    case'in':$rz='India';break;
    case'io':$rz='British Indian Ocean Terr.';break;
    case'iq':$rz='Iraq';break;
    case'ir':$rz='Iran';break;
    case'is':$rz='Iceland';break;
    case'it':$rz='Italy';break;
    case'je':$rz='Jersey';break;
    case'jm':$rz='Jamaica';break;
    case'jo':$rz='Jordan';break;
    case'jp':$rz='Japan';break;
    case'ke':$rz='Kenya';break;
    case'kg':$rz='Kyrgystan';break;
    case'kh':$rz='Cambodia';break;
    case'ki':$rz='Kiribati';break;
    case'km':$rz='Comoros';break;
    case'kn':$rz='Saint Kitts and Nevis';break;
    case'kp':$rz='Korea, DPR';break;
    case'kr':$rz='Korea, Republic of';break;
    case'kw':$rz='Kuwait';break;
    case'ky':$rz='Cayman Islands';break;
    case'kz':$rz='Kazakhstan';break;
    case'la':$rz='Lao PDR';break;
    case'lb':$rz='Lebanon';break;
    case'lc':$rz='Saint Lucia';break;
    case'li':$rz='Liechtenstein';break;
    case'lk':$rz='Sri Lanka';break;
    case'lr':$rz='Liberia';break;
    case'ls':$rz='Lesotho';break;
    case'lt':$rz='Lithuania';break;
    case'lu':$rz='Luxembourg';break;
    case'lv':$rz='Latvia';break;
    case'ly':$rz='Libyan Arab Jamahiriya';break;
    case'ma':$rz='Morocco';break;
    case'mc':$rz='Monaco';break;
    case'md':$rz='Moldova';break;
    case'mg':$rz='Madagascar';break;
    case'mh':$rz='Marshall Islands';break;
    case'mk':$rz='Macedonia';break;
    case'ml':$rz='Mali';break;
    case'mm':$rz='Myanmar';break;
    case'mn':$rz='Mongolia';break;
    case'mo':$rz='Macau';break;
    case'mp':$rz='Northern Mariana Is.';break;
    case'mq':$rz='Martinique';break;
    case'mr':$rz='Mauritania';break;
    case'ms':$rz='Montserrat';break;
    case'mt':$rz='Malta';break;
    case'mu':$rz='Mauritius';break;
    case'mv':$rz='Maldives';break;
    case'mw':$rz='Malawi';break;
    case'mx':$rz='Mexico';break;
    case'my':$rz='Malaysia';break;
    case'mz':$rz='Mozambique';break;
    case'na':$rz='Namibia';break;
    case'nc':$rz='New Caledonia';break;
    case'ne':$rz='Niger';break;
    case'nf':$rz='Norfolk Island';break;
    case'ng':$rz='Nigeria';break;
    case'ni':$rz='Nicaragua';break;
    case'nl':$rz='The Netherlands';break;
    case'no':$rz='Norway';break;
    case'np':$rz='Nepal';break;
    case'nr':$rz='Nauru';break;
    case'nt':$rz='Neutral Zone';break;
    case'nu':$rz='Niue';break;
    case'nz':$rz='New Zealand';break;
    case'om':$rz='Oman';break;
    case'pa':$rz='Panama';break;
    case'pe':$rz='Peru';break;
    case'pf':$rz='French Polynesia';break;
    case'pg':$rz='Papua New Guinea';break;
    case'ph':$rz='Philippines';break;
    case'pk':$rz='Pakistan';break;
    case'pl':$rz='Poland';break;
    case'pm':$rz='St. Pierre and Miquelon';break;
    case'pn':$rz='Pitcairn';break;
    case'pr':$rz='Puerto Rico';break;
    case'pt':$rz='Portugal';break;
    case'pw':$rz='Palau';break;
    case'py':$rz='Paraguay';break;
    case'qa':$rz='Qatar';break;
    case're':$rz='Reunion';break;
    case'ro':$rz='Romania';break;
    case'ru':$rz='Russia';break;
    case'rw':$rz='Rwanda';break;
    case'sa':$rz='Saudi Arabia';break;
    case'sb':$rz='Solomon Islands';break;
    case'sc':$rz='Seychelles';break;
    case'sd':$rz='Sudan';break;
    case'se':$rz='Sweden';break;
    case'sg':$rz='Singapore';break;
    case'sh':$rz='St. Helena';break;
    case'si':$rz='Slovenia';break;
    case'sj':$rz='Svalbard and Jan Mayen Is.';break;
    case'sk':$rz='Slovakia';break;
    case'sl':$rz='Sierra Leone';break;
    case'sm':$rz='San Marino';break;
    case'sn':$rz='Senegal';break;
    case'so':$rz='Somalia';break;
    case'sr':$rz='Surinam';break;
    case'st':$rz='Sao Tome and Principe';break;
    case'su':$rz='USSR';break;
    case'sv':$rz='El Salvador';break;
    case'sy':$rz='Syrian Arab Republic';break;
    case'sz':$rz='Swaziland';break;
    case'tc':$rz='The Turks & Caicos Islands';break;
    case'td':$rz='Chad';break;
    case'tf':$rz='French Southern Territories';break;
    case'tg':$rz='Togo';break;
    case'th':$rz='Thailand';break;
    case'tj':$rz='Tajikistan';break;
    case'tk':$rz='Tokelau';break;
    case'tm':$rz='Turkmenistan';break;
    case'tn':$rz='Tunisia';break;
    case'to':$rz='Tonga';break;
    case'tp':$rz='East Timor';break;
    case'tr':$rz='Turkey';break;
    case'tt':$rz='Trinidad and Tobago';break;
    case'tv':$rz='Tuvalu';break;
    case'tw':$rz='Taiwan';break;
    case'tz':$rz='Tanzania';break;
    case'ua':$rz='Ukraine';break;
    case'ug':$rz='Uganda';break;
    case'uk':$rz='United Kingdom';break;
    case'um':$rz='United States M.O Is.';break;
    case'us':$rz='United States';break;
    case'uy':$rz='Uruguay';break;
    case'uz':$rz='Uzbekistan';break;
    case'va':$rz='Holy See (Vatican)';break;
    case'vc':$rz='St Vincent & Grenadines';break;
    case've':$rz='Venezuela';break;
    case'vg':$rz='Virgin Islands British';break;
    case'vi':$rz='Virgin Islands U.S';break;
    case'vn':$rz='Vietnam';break;
    case'vu':$rz='Vanuatu';break;
    case'wf':$rz='Wallis and Futuna Islands';break;
    case'ws':$rz='Samoa';break;
    case'ye':$rz='Yemen';break;
    case'yt':$rz='Mayotte';break;
    case'yu':$rz='Yugoslavia';break;
    case'za':$rz='South Africa';break;
    case'zm':$rz='Zambia';break;
    case'zr':$rz='Zaire';break;
    case'zw':$rz='Zimbabwe';break;
  default:$rz='';break;
  }
  $img="$dirFlags/$ty.$extFlag";
  if(is_file($img)) {
    $string = "<center><img src=\"$img\"alt=\"$rz\"></center></td><td>$rz";
  } else {
    $string = "</td><td>$rz";
  }
  return $string;
}

/*********************************************************************************/
/* Function: plotHistory
/* Role: returns a string with a link to a plot with the evolution of the mosy 
/*    popular qty with time 
/* Parameters: 
/*   - $c: connection to the database
/*   - $table: base name for sql tables
/*   - $what: can be "os", "browser", "country"
/* Output:
/*   - a link to the plot
/* Created: 09/2005
/*********************************************************************************/
function plotHistory($c,$table, $what) {
// We get the nplot most common qties (country, OS, browser out of the db, 
// then plot the history for them
$nplot = 8;
// Getting the qties to plot
$req = "SELECT label,SUM(count) as count FROM ${table}_$what GROUP BY label ORDER BY count DESC LIMIT 0,$nplot;";
$res = mysql_query($req,$c);
$qty = array();
$count = array();
while($row = mysql_fetch_object($res)) {
	$qty[] = $row->label;
	$count[] = $row->count;
}
// Get the monthly data (total)
// Pull number of counts for each month
$req = "SELECT date,SUM(count) as count FROM ${table}_$what GROUP BY date;";
$res = mysql_query($req,$c);
$nMonth = 0;
$date = array();
$total = array();
while($row = mysql_fetch_object($res)) {
	$date[$nMonth] = $row->date;
	$total[$nMonth] = $row->count;
	$nMonth += 1;
}
// For each of the qty to plot, get the monthly data
$datecount = array();
for ($j=0;$j<$nplot;$j++) {
	$req = "SELECT date,count FROM ${table}_$what WHERE label='$qty[$j]';";
	$res = mysql_query($req,$c);
	while($row = mysql_fetch_object($res)) {
		$i = array_search($row->date, $date); 
		$datecount[$i][$j] = $row->count;
	}
}
// Plot the history
$start = 100000000000;
$end = 0;
$maxcount = 0;
$string = "<?\n\$date_data = array(";
$max = count ($qty);
for ($i=0;$i<$nMonth;$i++) {
	$time = strtotime($date[$i]);
	if ($time<$start) {$start=$time;}
	if ($time>$end) {$end=$time;}
	if ($i>0) {
		$string .= "\n,array(\"\",$time";
	} else {
		$string .= "\narray(\"\",$time";
	}
	$other = 100.;
	for ($j=0;$j<$max;$j++) {
		if ($datecount[$i][$j] == "") $datecount[$i][$j] = 0;
		$tt = intval(1000.*$datecount[$i][$j]/$total[$i])/10;
		$other -= $tt;
		if ($tt>$maxcount) {$maxcount = $tt;}
		$string .= ",$tt";
	}
	if ($other>$maxcount) {$maxcount=$tt;}
	$string .= ",$other)";
}
$legende = "\"$qty[0]\"";
for ($j=1;$j<$max;$j++) {
	$legende .= ",'$qty[$j]'";
}
$legende .= ",\"Other\"";
$string .= "\n);\n\$start=$start;\n\$end=$end;\n\$maxY=$maxcount;\n\$plottype=\"lines\";"; 
$string .= "\n\$legende = array($legende);\n\$width = 600;\n\$height = 300;\n\$ylabel = \"% of total\";\n?>";
if ((($start+2679000) != $end)&&$maxcount>0) {
	$timecall = time();
	$temp = fopen ("./tmp/tmp.$timecall.txt.php", 'w');
	fwrite($temp, $string);
	fclose($temp);
	return "<img src=\"./plotStat.php?file=tmp.$timecall.txt.php\" alt=\"History\">"; 
} else {
	return "Nothing yet";
}
}

/*********************************************************************************/
/* Function: plotThisMonth
/* Role: returns a string with a link to a plot with the plot for this month
/* Parameters: 
/*   - $c: connection to the database
/*   - $table: base name for sql tables
/*   - $what: can be "os", "browser", "country"
/* Output:
/*   - a link to the plot
/* Created: 09/2005
/*********************************************************************************/
function plotThisMonth($c,$table, $what) {
$nplot = 6;
$timecall = time();
$thismonth = date("Y-m-01");
// get the most popular QTY
$req = "SELECT label,count FROM ${table}_$what WHERE date='$thismonth' ORDER BY count DESC LIMIT 0,$nplot;";
$res = mysql_query($req,$c);
$thismonthNQty = 0;
$totalthismonth = 0;
while($row = mysql_fetch_object($res)) {
	$thismonthqty[$thismonthNQty] = $row->label;
	$thismonthcount[$thismonthNQty] = $row->count;
	$thismonthNQty += 1;
	$totalthismonth -= $row->count;
}
if ($totalthismonth < 0) {
	$req = "SELECT SUM(count) as count FROM ${table}_$what WHERE date='$thismonth' GROUP BY date;";
	$res = mysql_query($req,$c);
	$row=mysql_fetch_array($res);
	$total=$row['count'];
	$string = "<?\n\$date_data = array(";
	$max = min($thismonthNQty,$nplot);
	for ($j=0;$j<$max;$j++) {
		$tt = $thismonthcount[$j];
		if ($j>0) {
			$string .= ",$tt";
			$legende .= ",\"$thismonthqty[$j]\"";
		} else {
			$string .= "array(\"\",$tt";
			$legende = "\"$thismonthqty[0]\"";
		}
	}
	$other = $totalthismonth + $total;
	$string .= ",$other)";
	$legende .= ",\"Other\"";
	$string .= "\n);\n\$plottype=\"pie\";\n\$legende = array($legende);\n\$width = 500;\n\$height = 200;\n?>";
	$temp = fopen ("./tmp/tmp2.$timecall.txt.php", 'w');
	fwrite($temp, $string);
	fclose($temp);
	return "<img src=\"./plotStatPie.php?file=tmp2.$timecall.txt.php\" alt=\"This month\">";
} 
return "&nbsp;<br>No access recorded during for the month: $thismonth<br>&nbsp;";
}

/*********************************************************************************/
/* Function: tableHistory
/* Role: returns a string with a table with numbers
/* Parameters: 
/*   - $c: connection to the database
/*   - $table: base name for sql tables
/*   - $sid: site id
/*   - $what: can be "os", "browser", "country"
/*   - $full: true if you want a full list, false for a list limited to the one 
/*      that are more than 1% of the total.
/* Output:
/*   - a link to the plot
/* Created: 09/2005
/*********************************************************************************/
function tableHistory($c,$table, $sid, $what,$full=false) {
$string = "<table class=\"stat\">
<tr><td class=\"title\" colspan=\"10\">Recent statistics</td></tr>
<tr><td class=\"caption\" colspan=\"2\"></td><td class=\"caption\" colspan=\"2\">This month</td><td class=\"caption\" colspan=\"2\">Last month</td><td class=\"caption\" colspan=\"2\">Two month ago</td><td class=\"caption\" colspan=\"2\">Total</td></tr>
<tr><td colspan=\"2\">Total number of access</td>";
// Getting the info out of the database, we'll do it in two steps: total numbers, and numbers for this month, last month, and two month ago...
$thismonth = date("Y-m-01");
$lastmonth = date("Y-m-01",strtotime("-1 month"));
$lastlastmonth = date("Y-m-01",strtotime("-2 month"));
$req = "SELECT date, SUM(count) as count FROM ${table}_$what GROUP BY date;";
$total = array();
$bigTotal = 0;
$res = mysql_query($req,$c);
while($row = mysql_fetch_object($res)) {
	$total[$row->date] = $row->count;
	$bigTotal += $row->count;
}
// Now, we need numbers for qties, totals, for this month, last month, and the month before... This request can be huge...
if (!$full) {
	$limit = intval($bigTotal/100);
} else {
	$limit = 0;
}
$req = "SELECT label, SUM(count) as bigcount FROM ${table}_$what GROUP BY label ORDER BY bigcount DESC;";
$res = mysql_query($req,$c);
$arrayTotal = array();
$ok = true;
while(($row = mysql_fetch_object($res))&&$ok) {
	if ($row->bigcount >= $limit) {
		$arrayTotal[$row->label] = $row->bigcount;
	} else {
		$ok = false;
	}
}
// Number for thismonth, the month before and the two month ago...
$req = "SELECT date,label,count FROM ${table}_$what WHERE date='$thismonth' OR date='$lastmonth' OR date='$lastlastmonth';";
$res = mysql_query($req,$c);
$arrayMonthly = array();
while($row = mysql_fetch_object($res)) {
	if ($arrayTotal[$row->label]>0) {
		$arrayMonthly[$row->label][$row->date]=$row->count;
	}
}
$toPull[0] = $thismonth;
$toPull[1] = $lastmonth;
$toPull[2] = $lastlastmonth;
$counted[0] = 0;
$counted[1] = 0;
$counted[2] = 0;
$counted[3] = 0;
for ($i=0;$i<3;$i++) {
	$n = $total[$toPull[$i]];
	$string .= "<td>$n</td><td>&nbsp;</td>";
}
$string .= "<td>$bigTotal</td><td>&nbsp;</td></tr>\n";
foreach ($arrayTotal as $key=>$alltime) {
	if ($what == "country") {
		$string .= "\n<tr><td>".countryNameFlag($key)."</td>";
	} else if ($what=="browser") {
		$string .= "\n<tr><td>".browserImgName($key)."</td>";
	} else if ($what=="os") {
		$string .= "\n<tr><td>".osImgName($key)."</td>";
	} else {
		$string .= "\n<tr><td colspan=\"2\">$key</td>";
	}
	for ($i=0;$i<3;$i++) {
		$n = $arrayMonthly[$key][$toPull[$i]];
		$counted[$i] += $n;
		if ($n == "") $n = 0;
		if ($total[$toPull[$i]] == 0) {$pc = 0.0;} else {$pc = number_format(100*$n/$total[$toPull[$i]],1);}
		$string .= "<td>$n</td><td>$pc %</td>";
	}
	$n = $arrayTotal[$key];
	$counted[3] += $n;
	$pc = number_format(100*$n/$bigTotal,1);
	$string .= "<td>$n</td><td>$pc %</td></tr>\n";
}
if (!$full) {
	$string .= "\n<tr><td colspan=\"2\">Other</td>";
	for ($i=0;$i<3;$i++) {
		$n = $total[$toPull[$i]]-$counted[$i];
		if ($total[$toPull[$i]] == 0.0) {$pc = 0.0;} else {$pc = number_format(100*$n/$total[$toPull[$i]],1);}
		$string .= "<td>$n</td><td>$pc %</td>";
	}
	$n = $bigTotal-$counted[3];
	if ($bigTotal == 0.0) {$pc = 0.0;} else {$pc = number_format(100*$n/$bigTotal,1);}
	$string .= "<td>$n</td><td>$pc %</td>\n";
	$string .= "<tr><td colspan=\"10\" align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=$what&amp;toplot=fulllist\">Full List</a></td></tr>\n";
}
$string .= "</table>\n";
return $string;
}

/*********************************************************************************/
/* Function: echoMonthly
/* Role: stats results for monthly quantity, such as OS, browser, or country
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: id of the website
/*   - $what: can be "os", "browser", "country"
/*   - $toplot: can be "history", "fulllist"
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/* Split in several subroutines and fully rewritten, 09/2005
/*********************************************************************************/
function echoMonthly($table, $site, $what, $toplot) {
global $server;
global $user;
global $password;
global $base;

$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");

if ($toplot == 'history') {
	$title = "History";
	$plot = plotHistory($c,$table, $what);
	$link = "<a href=\"./index.php?mode=stats&amp;sid=$site&amp;show=$what&amp;toplot=thismonth\">Plot for this month</a>";
} elseif ($toplot != "fulllist") {
	$title = "This month";
	$plot = plotThisMonth($c,$table, $what);
	$link = "<a href=\"./index.php?mode=stats&amp;sid=$site&amp;show=$what&amp;toplot=history\">Plot history</a>";
}
if ($toplot != "fulllist") {
	echo "<table class=\"stat\">
<tr><td class=\"title\">$title</td></tr>
<tr><td align=\"center\">$plot</td></tr>
<tr><td align=\"center\">$link</td></tr>
</table>\n"; 
	echo tableHistory($c, $table, $site, $what, false);
} else {
	echo tableHistory($c, $table, $site, $what, true);
}
@mysql_close ($c);
}

?>
