<?
/***************************************************************************
phpTrafficA @soft.ZoneO.net
Copyright (C) 2004-2006 ZoneO-soft, S. Merkel (dude@zoneo.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

/*********************************************************************************/
/* Function: newTrend
/* Role: tries to figure out new trend over a time period
/* Parameters: 
/*   - $table: base name for sql tables
/*   - $site: root of the website
/*   - $sid: the site ID
/*   - $interval: time interval, in days
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/*********************************************************************************/

function echoNewTrend($table, $site, $sid, $interval) {
global $DEBUG;
global $server;
global $user;
global $password;
global $base;
global $config_table;
// Number of pages, keywords and referrers to list in the tables
$ntop = 10;

echo "<table align=\"center\">
<tr><td align=\"center\" colspan=\"3\">Interval of analysis</td></tr>
<tr><td align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=new&amp;interval=7\">7 days</a></td>
<td align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=new&amp;interval=30\">1 month</a></td>
<td align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=new&amp;interval=120\">3 months</a></td></tr>
</table>";

$today = date("Y-m-d");
$first = date("Y-m-d", strtotime("-$interval days"));
$two = 2*$interval;
$second = date("Y-m-d", strtotime("-$two days"));
$three = 3*$interval;
$third = date("Y-m-d", strtotime("-$three days"));

$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
// Gaining and loosing queries
echo "<table class=\"stat\">
<tr><td class=\"title\" colspan=\"4\">Pages on the rise (hits/day)</td><td class=\"title\" colspan=\"4\">Pages on the decline (hits/day)</td></tr>
<tr><td class=\"caption\">&nbsp;</td><td class=\"caption\">Last $interval days</td><td class=\"caption\">Previous $interval days</td><td class=\"caption\">Gain</td>
<td class=\"caption\">&nbsp;</td><td class=\"caption\">Last $interval days</td><td class=\"caption\">Previous $interval days</td><td class=\"caption\">Loss</td></tr>";
$req = "SELECT label,SUM(count) as count FROM ${table}_acces WHERE date>='$first' GROUP BY label";
$res = mysql_query($req,$c);
$n = 0;
while ($row = mysql_fetch_object($res)) {
	$count[$row->label] = $row->count;
	$n += 1;
}
if ($n > 0) {
	$req = "SELECT label,SUM(count) as count FROM ${table}_acces WHERE date>='$second' and date<'$first' GROUP BY label";
	$res = mysql_query($req,$c);
	$twoT = array();
	while ($row = mysql_fetch_object($res)) {
		$twoT[$row->label] = $row->count;
	}
	// Calculating daily average (need to do separatly because days with no access are not
	// in the database...
	$req = "SELECT id,added FROM ${table}_pages";
	$res = mysql_query($req,$c);
	while ($row = mysql_fetch_object($res)) {
		$added[$row->id] = $row->added;
	}
	while (list($key, $thiscount) = each($count)) {
		//echo "<br>For pageid $key, it was added on $added[$key], we have a count of $thiscount";
		if ($first>$added[$key]) {
			$count[$key] = $thiscount/($interval+1);
		} else {
			$thisinterval = (strtotime($today)-strtotime($added[$key])+86400.)/86400.;
			$count[$key] = $thiscount/$thisinterval;
		}
		//echo " and the average becomes $count[$key].\n";
	}
	reset($count);
	while (list($key, $thiscount) = each($twoT)) {
		if ($second>$added[$key]) {
			$twoT[$key] = $thiscount/($interval+1);
		} else {
			$thisinterval = (strtotime($first)-strtotime($added[$key])+86400.)/86400.;
			$twoT[$key] = $thiscount/$thisinterval;
		}
	}
	reset($twoT);
	// Calculating gain and losses
	while (list($key, $thiscount) = each($count)) {
		$gain[$key] = $thiscount - $twoT[$key];
		$loss[$key] = $twoT[$key]-$thiscount;
	}
	arsort($gain);
	reset($gain);
	arsort($loss);
	reset($loss);
	$max = min($ntop,$n);
	for ($i=0;$i<$max;$i++) {
		list($thisid, $thiscount) = each($gain);
		$sql2 = "SELECT name FROM ${table}_pages WHERE id=$thisid";
		$res2 = mysql_query($sql2,$c);
		$row2 = mysql_fetch_object($res2);
		$page = shortenPage($row2->name,50);
		$av = number_format($count[$thisid],1);
		$av2 = number_format($twoT[$thisid],1);
		$av3 = $av-$av2;
		//
		list($thisidL, $thiscount) = each($loss);
		$pageL = shortenPage(pagename($c,$table,$thisidL),50);
		$avL = number_format($count[$thisidL],1);
		$av2L = number_format($twoT[$thisidL],1);
		$av3L = $av2L-$avL;
		//
		if (($av3 > 0) || ($av3L>0)) {
			echo "\n<tr>";
			if ($av3>0) {
				echo "\n<td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$thisid\">$page</a></td><td>$av</td><td>$av2</td><td>$av3</td>";
			} else {
				echo "\n<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>";
			}
			if ($av3L>0) {
				echo "\n<td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$thisidL\">$pageL</a></td><td>$avL</td><td>$av2L</td><td>$av3L</td>";
			} else {
				echo "\n<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>";
			}
		}
	}
} else {
	echo "<tr><td colspan=\"8\" align=\"center\">Nothing yet</td></tr>";
}
echo "\n</table>";

// Pages with a large number of new keywords
$req = "SELECT page,COUNT(keyword) AS key_num FROM ${table}_keyword  WHERE first>='$first' GROUP BY page";
$res = mysql_query($req,$c);
$newkeys = array();
$nkeys = 0;
while ($row = mysql_fetch_object($res)) {
	$newkeys[$row->page] = $row->key_num;
	$nkeys += 1;
}
// Pages with a large number of new referrers
$req = "SELECT page,COUNT(address) AS key_num FROM ${table}_referrer  WHERE first>='$first' GROUP BY page";
$res = mysql_query($req,$c);
$newrefs = array();
$nrefs = 0;
while ($row = mysql_fetch_object($res)) {
	$newrefs[$row->page] = $row->key_num;
	$nrefs += 1;
}
arsort($newkeys);
arsort($newrefs);
echo "\n<table class=\"stat\">
<tr><td class=\"title\" colspan=\"4\">Pages with new keywords and referrers</td></tr>
<tr><td class=\"caption\" colspan=\"2\">Number of new keywords in the last $interval days</td><td class=\"caption\" colspan=\"2\">Number of new referrers in the last $interval days</td></tr>";
if (($nkeys*$nrefs)>0) {
	for ($i=0;$i<$ntop;$i++) {
		if (list($thisid, $thiscount) = each($newkeys)) {
			$newk = 1;
			$page2 = shortenPage(pagename($c,$table,$thisid));
			$string="<td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$thisid\">$page2</a></td><td>$thiscount</td>";
		} else {
			$newk=0;
			$string="<td>&nbsp;</td><td>&nbsp;</td>";
		}
		if (list($thisid, $thiscount) = each($newrefs)) {
			$newr = 1;
			$page2 = shortenPage(pagename($c,$table,$thisid));
			$string2="<td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$thisid\">$page2</a></td><td>$thiscount</td>";
		} else {
			$newr=0;
			$string2="<td>&nbsp;</td><td>&nbsp;</td>";
		}
		if ($newk || $newr) {
			echo "\n<tr>".$string.$string2."</tr>";
		}
	}
} else {
echo "<tr><td colspan=\"4\" align=\"center\">Nothing yet</td></tr>";
}
echo "\n</table>";

// New popular keywords during this period
echo "<table class=\"stat\">";
echo "<tr><td class=\"title\" colspan=\"3\">New in the last $interval days</td></tr>";
echo "\n<tr><td class=\"caption\" colspan=\"3\">Keywords</td></tr>";
$req = "SELECT page,keyword,count,engine FROM ${table}_keyword WHERE first>='$first' ORDER BY count DESC LIMIT 0,$ntop;";
$res = mysql_query($req,$c);
$n = 0;
while ($row = mysql_fetch_object($res)) {
	$n += 1;
	$key = htmlentities ($row->keyword, ENT_NOQUOTES, 'UTF-8');
	$engine = $row->engine;
	$count = $row->count;
	$pageid2 = $row->page;
	$page2 = shortenPage(pagename($c,$table,$pageid2));
	echo "\n<tr><td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$pageid2\">$page2</a></td><td>$engine: $key</td><td>$count hits</td></tr>";
}
if ($n == 0) {
	echo "\n<tr><td colspan=\"3\" align=\"center\">Nothing yet</td></tr>";
}
// New popular referrers during this period
echo "\n<tr><td class=\"caption\" colspan=\"3\">Referrers</td></tr>";
$req = "SELECT page,address,count FROM ${table}_referrer WHERE first>='$first' ORDER BY count DESC LIMIT 0,$ntop;";
$res = mysql_query($req,$c);
$n = 0;
while ($row = mysql_fetch_object($res)) { 
	$n += 1;
	$ref = $row->address;
	$count = $row->count;
	$pageid2 = $row->page;
	$page2 = shortenPage(pagename($c,$table,$pageid2));
	$ref = cleanURL($ref);
	$refS = shortenURL($ref);
	echo "\n<tr><td><a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=$pageid2\">$page2</a></td><td><a href=\"$ref\" target=\"_new\">$refS</a></td><td>$count hits</td></tr>";
}
if ($n == 0) {
	echo "\n<tr><td colspan=\"2\"><div align=\"center\">Nothing yet</div></td></tr>";
}
echo "\n</table>\n";
@mysql_close ($c);
}

?>
