<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2006 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

// Functions for full path analysis: entry pages, exit pages, path...
// Everything except visitor retention, visit duration, and path on latest visitors

/***********************************************************************
/* Function: entryExit
/* Role: prepares a table with entry, exit, and magnet pages
/* Parameters:
/*   - $table
/*   - $site
/*   - $sid
/*   - $sort: can be "path" or "visits" to sort by number of path or number of visits
/* Output:
/*   - Echos whatever it finds
/* Created: 11/2005
************************************************************************/
function entryExit($table, $site, $sid,$sort) {
global $server, $user, $password, $base;
$ntop = 10;

$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
$sql = "SELECT SUM(count) as count, COUNT(id) as diff FROM ${table}_path";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpath = $row->diff;
$totalvisits = $row->count;
// echo "<table align=\"center\">
// <tr><td align=\"center\" colspan=\"2\"><b>Sort by</b></td></tr>";
// if ($sort == "path") {
// 	echo "<tr><td align=\"center\">Number of paths</td><td align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=entryexit&amp;sort=visits\">Number of visits</a></td></tr>";
// } else {
// 		echo "<tr><td align=\"center\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=entryexit&amp;sort=path\">Number of paths</a></td><td align=\"center\">Number of visits</td></tr>";
// }
// echo "<tr><td colspan=\"2\">$totalpath paths/ $totalvisits visits in database</td></tr>
// </table>";
if ($totalpath > 0) {
	if ($sort == "path") {
		$order = "diff";
	} else {
		$order = "count";
	}
	// Entry pages
	$str = "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Entry pages</td></tr><tr><td class=\"caption\">Page</td><td class=\"caption\">N. paths</td><td class=\"caption\">Count</td></tr>\n";
	$sql = "SELECT entry,SUM(count) as count, COUNT(id) as diff FROM ${table}_path GROUP BY entry ORDER BY $order DESC LIMIT 0,$ntop;";
	$res = mysql_query($sql,$c);
	while($row = mysql_fetch_object($res)) {
		$pageid = $row->entry;
		$count = $row->count;
		$npath = $row->diff;
		$pcpath = number_format(100.0*$npath/$totalpath,0);
		$pcvisits = number_format(100.0*$count/$totalvisits,0);
		$pagename = shortenPage(pagename($c,$table,$pageid));
		$str .= "<tr><td>".linksforpage($sid, $pagename, $pageid)."</td><td>$pcpath% of paths</td><td>$pcvisits% of visits</td></tr>\n";
	}
	$str .= "</table>\n";
	echo $str;
	// Exit pages
	$str = "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Exit pages</td></tr><tr><td class=\"caption\">Page</td><td class=\"caption\">N. paths</td><td class=\"caption\">Count</td></tr>\n";
	$sql = "SELECT exit,SUM(count) as count, COUNT(id) as diff FROM ${table}_path GROUP BY exit ORDER BY $order DESC LIMIT 0,$ntop;";
	$res = mysql_query($sql,$c);
	while($row = mysql_fetch_object($res)) {
		$pageid = $row->exit;
		$npath = $row->diff;
		$count = $row->count;
		$pagename = shortenPage(pagename($c,$table,$pageid));
		$pcpath = number_format(100.0*$npath/$totalpath,0);
		$pcvisits = number_format(100.0*$count/$totalvisits,0);
		$str .= "<tr><td>".linksforpage($sid, $pagename, $pageid)."</td><td>$pcpath% of paths</td><td>$pcvisits% of visits</td></tr>\n";
	}
	$str .= "</table>\n";
	echo $str;
	// Magnet pages 
	$str = "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Magnet pages</td></tr>\n<tr><td class=\"caption\">Entry page</td><td class=\"caption\">N. Visits</td><td class=\"caption\">Efficiency</td></tr>\n";
	$sql = "SELECT entry,SUM(count) as count, SUM(length*count) as eff,SUM(length*count)/SUM(count) as av FROM ${table}_path GROUP BY entry ORDER BY eff DESC LIMIT 0,$ntop;";
	$res = mysql_query($sql,$c);
	while($row = mysql_fetch_object($res)) {
		$pageid = $row->entry;
		$av = $row->av;
		$count = $row->count;
		$bigtotal = $row->eff;
		$pagename = shortenPage(pagename($c,$table,$pageid));
		$str .= "<tr><td>".linksforpage($sid, $pagename, $pageid)."</td><td>$count visits</td><td>$av clicks/visit</td></tr>\n";
	}
	$str .= "</table>\n";
	echo $str;
} else {
	$str = "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Entry pages</td></tr><tr><td class=\"caption\">Page</td><td class=\"caption\">N. paths</td><td class=\"caption\">Count</td></tr>\n<tr><td colspan=\"3\" align=\"center\">Nothing yet</td></tr>\n</table>\n";
	$str .= "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Exit pages</td></tr><tr><td class=\"caption\">Page</td><td class=\"caption\">N. paths</td><td class=\"caption\">Count</td></tr>\n<tr><td colspan=\"3\" align=\"center\">Nothing yet</td></tr>\n</table>\n";
	$str .= "<table class=\"stat\">\n<tr><td colspan=\"3\"class=\"title\">Magnet pages</td></tr>\n<tr><td class=\"caption\">Entry page</td><td class=\"caption\">N. Visits</td><td class=\"caption\">Efficiency</td></tr>\n<tr><td colspan=\"3\" align=\"center\">Nothing yet</td></tr>\n</table>\n";
	echo $str;
}
@mysql_close ($c);
}

/***********************************************************************
/* Function pathDesigner
/* Role: for given path, finds out where visitors came from, and where
/*       they went
/* Parameters:
/*   - $table
/*   - $site
/*   - $sid
/*   - $pageid: the path, with each element separated by a |, eg, |43|32|32|,
/*      number 0 indicate a entry (an exit) from (to) the outside world
/* Output:
/*   - Echos whatever it finds
/* Created: 02/2005
***********************************************************************/
function pathDesigner($table, $site, $sid, $pageid) {
global $server, $user, $password, $base;

//
// Cleaning up the path, check if we want to path to start or finish here
//
$wantfirst = FALSE;
$wantlast = FALSE;
$patharray = explode("|",$pageid);
if ($patharray[0] == 0) {
	$wantfirst = TRUE;
	array_shift($patharray);
}
if ($patharray[count($patharray)-1] == 0) {
	$wantlast = TRUE;
	array_pop($patharray);
}
$pageidstr = "|".implode("|",$patharray)."|";
$length = strlen($pageidstr);
$extrasql = "";
if ($wantfirst) $extrasql .= " AND INSTR(path,'$pageidstr')=1 ";
if ($wantlast) $extrasql .= " AND RIGHT(path,$length)='$pageidstr' ";

//
// Connection to database
//
$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");

//
// Main properties: number of path and this kind of things
// Total number of path and visits in database
//
$sql = "SELECT SUM(count) as visits, COUNT(id) as paths FROM ${table}_path";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpath = $row->paths;
$totalvisits = $row->visits;
// Total number of path and visits that match the desired one
$sql = "SELECT SUM(count) as count, COUNT(id) as diff FROM ${table}_path WHERE INSTR(path,'$pageidstr')>0 $extrasql";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpathpage = $row->diff;
$totalvisitspage = $row->count;
// Got to find how many start with this path
$sql = "SELECT SUM(count) as count, COUNT(id) as diff FROM ${table}_path WHERE INSTR(path,'$pageidstr')=1 $extrasql";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpathstart = $row->diff;
$totalvisitsstart = $row->count;
// Got to find the path that finish this way...
$sql = "SELECT SUM(count) as count, COUNT(id) as diff FROM ${table}_path WHERE RIGHT(path,$length)='$pageidstr' $extrasql";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpathend = $row->diff;
$totalvisitsend = $row->count;

//
// If  there was no path recorded, we stop here with a little word...
//
if ($totalvisitspage < 1) {
	$pagename = shortenPage(pagename($c,$table,$pageid));
	$str = "<table class=\"stat\">\n<tr><td colspan=\"2\" class=\"title\">Path analysis</td></tr>\n<tr><td class=\"path\">&nbsp;<br>Out of $totalvisits visitors in the database, nobody went through the page $pagename ....<br>&nbsp;</td></tr>\n</table>";
	echo $str;
	return;
}

//
// Starting the table
//
$pc = number_format(100.0*$totalvisitspage/$totalvisits,1);
$str = "<table class=\"stat\">\n<tr><td colspan=\"3\" class=\"title\">Path analysis</td></tr>
<tr><td class=\"path\" colspan=\"2\">&nbsp;<br>From $totalvisits visitors, $totalvisitspage ($pc%) used a path like this:<br>&nbsp;</td><td class=\"path\" colspan=\"1\" align=\"right\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=studypath&amp;pageid=$pageid\" class=\"basic\">Study visitors flow along this path</a></td></tr>\n<tr class=\"path\"><td class=\"path\" align=\"left\" width=\"200px\">";
if (!$wantfirst) $str .= "<div class=\"leftbox\">";

//
// Entry from outside world
//
$pc = number_format(100.0*$totalvisitsstart/$totalvisitspage,1);
$total = $totalvisitsstart;
$str .= "<table class=\"postitS\"><tr><td colspan=\"2\"><b>Outside world</b><br> $totalvisitsstart visitors ($pc%)</td></tr><tr><td colspan=\"2\">";
if ($totalvisitsstart > 0) {
	$str .= "<b>Keywords</b>: ";
	$req = "SELECT keyword FROM ${table}_keyword WHERE page=".$patharray[0]." GROUP BY keyword ORDER BY count DESC LIMIT 0,5;";
	$res = mysql_query($req,$c);
	while ($row = mysql_fetch_object($res)) {
		$key = $row->keyword;
		$str .=" $key, ";
	}
	$str .= "...<br><b>Referrers</b>: ";
	$req = "SELECT address,count as count FROM ${table}_referrer WHERE page=".$patharray[0]." ORDER BY count DESC LIMIT 0,5;";
	$res = mysql_query($req,$c);
	while ($row = mysql_fetch_object($res)) {
		$ref = $row->address;
		$refC=cleanURL($ref);
		$refS = shorten($refC,15);
		if ($refS == $refC) {$extra = "";} else {$extra="...";}
		$str .= "<a href=\"$refC\" class=\"basic\" target=_new>$refS$extra</a>, ";
	}  
	$str .= "...";
} 
$str .= "</td></tr>";
$link0 = "<a href=\"index.php?mode=stats&amp;sid=$sid&amp;show=page&amp;pageid=".$patharray[0]."\" class=\"basic\">More info</a>";
$link1 = "";
if ((!$wantfirst) &&  ($totalvisitsstart>0)) $link1 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=0|$pageid\" class=\"basic\">Add to path</a>";
$str .= "<tr><td>$link0</td><td>$link1</td></tr></table>\n";

//
// Getting what is before the path, in general...
//
$sql = "SELECT SUBSTRING_INDEX(SUBSTRING(path,1,INSTR(path,'$pageidstr')-1),'|',-1) as previous, SUM(count) as total FROM ${table}_path WHERE INSTR(path,'$pageidstr')>1 $extrasql GROUP BY previous ORDER BY total DESC LIMIT 0,7";
$res = mysql_query($sql,$c);
while($row = mysql_fetch_object($res)) {
	$previous = $row->previous;
	$thistotal = $row->total;
	$total += $thistotal;
	$pc = number_format(100.0*$thistotal/$totalvisitspage,1);
	$pagename = shortenPage(pagename($c,$table,$previous));
	$link1 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$previous|$pageid\" class=\"basic\">Add to path</a>";
	$link2 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$previous\" class=\"basic\">Center here</a>";
	$str .= "<table class=\"postitS\"><tr><td colspan=\"2\">$pagename<br> $thistotal visitors ($pc%)</td></tr><tr><td>$link1</td><td>$link2</td></tr></table>\n";
}
if (!$wantfirst) {
	$rest = $totalvisitspage - $total;
	$pc = number_format(100.0*$rest/$totalvisitspage,1);
	$str .= "<table class=\"postitS\"><tr><td><b>Other</b><br> $rest visitors ($pc%)</td></tr></table></div>\n</td>\n";
} else {
	$str .= "</td>\n";
}
$str .= "<td class=\"path\" align=\"center\">";

//
// Putting the path itself
//
foreach ($patharray as $page) {
	$pagename = shortenPage(pagename($c,$table,$page));
	$link2 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$page\" class=\"basic\">Center here</a>";
	$str .= "<div class=\"postitnormal\">$pagename<br>$link2</div>";
}
if (!$wantlast) {
	$str .= "</td><td class=\"path\" align=\"right\" width=\"200px\"><div class=\"rightbox\">";
} else {
	$str .= "</td><td class=\"path\" align=\"right\" width=\"200px\">";
}

//
// Exit to outside world
//
$pc = number_format(100.0*$totalvisitsend/$totalvisitspage,1);
$total = $totalvisitsend;
if ($wantlast) {
$str .= "<table class=\"postitS\"><tr><td><b>Outside world</b><br> $totalvisitsend visitors</td></tr></table>\n";
} else {
	if ($totalvisitsend > 0) {
		$link1 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$pageid|0\" class=\"basic\">Add to path</a>";
	} else {
		$link1 = "";
	}
	$str .= "<table class=\"postitS\"><tr><td><b>Outside world</b><br> $totalvisitsend visitors ($pc%)<br>$link1</td></tr></table>\n";
}

//
// Getting what was after
//
$sql = "SELECT SUBSTRING_INDEX(SUBSTRING(path,INSTR(path,'$pageidstr')+$length),'|',1) as next, SUM(count) as total FROM ${table}_path WHERE INSTR(path,'$pageidstr')>0 AND RIGHT(path,$length) != '$pageidstr' $extrasql GROUP BY next ORDER BY total DESC LIMIT 0,7";
$res = mysql_query($sql,$c);
while($row = mysql_fetch_object($res)) {
	$next = $row->next;
	$thistotal = $row->total;
	$total += $thistotal;
	$pc = number_format(100.0*$thistotal/$totalvisitspage,1);
	$pagename = shortenPage(pagename($c,$table,$next));
	$link1 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$pageid|$next\" class=\"basic\">Add to path</a>";
	$link2 = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$next\" class=\"basic\">Center here</a>";
	$str .= "<table class=\"postitS\"><tr><td colspan=\"2\">$pagename<br> $thistotal visitors ($pc%)</td></tr><tr><td>$link1</td><td>$link2</td></tr></table>\n";
}
if (!$wantlast) {
	$rest = $totalvisitspage - $total;
	$pc = number_format(100.0*$rest/$totalvisitspage,1);
	$str .= "<table class=\"postitS\"><tr><td><b>Other</b><br> $rest visitors ($pc%)</td></tr></table></div>\n";
}
$str .= "</td></tr>\n</table>\n";
echo $str;
@mysql_close ($c);
}

/***********************************************************************
/* Function studyPath
/* Role: studies the visitors flow along a given path
/* Parameters:
/*   - $table
/*   - $site
/*   - $sid
/*   - $pageid: the path, with each element separated by a |, eg, |43|32|32|,
/*      number 0 indicate a entry (an exit) from (to) the outside world
/* Output:
/*   - Echos whatever it finds
/* Created: 11/2005
************************************************************************/
function studyPath($table, $site, $sid, $pageid) {
global $server, $user, $password, $base;
// Arrow images properties
$widthTD = 250;
$heightTD = 30;
$widthLR = 30;
$heightLR = 150;
//
$wantfirst = FALSE;
$wantlast = FALSE;
$patharray = explode("|",$pageid);
if ($patharray[0] == 0) {
	$wantfirst = TRUE;
	array_shift($patharray);
}
if ($patharray[count($patharray)-1] == 0) {
	$wantlast = TRUE;
	array_pop($patharray);
}
$extrasql = "";
if ($wantfirst) $extrasql .= " AND INSTR(path,'$path')=1 ";
// if ($wantlast) $extrasql .= " AND RIGHT(path,$length)='$pageidstr' ";
$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
$str = "<table class=\"stat\">\n<tr><td class=\"title\" colspan=\"7\">Visitors flow</td></tr>\n";
reset($patharray);
if ($wantfirst) {
	// Origin of the paths = search engines, referrers...
	// First step: how do we get there, and how many people
	$id = $patharray[0];
	$path = "|$id|";
	// Start here
	$length = strlen($path);
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE SUBSTRING(path,1,$length) = '$path'";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$start = $row->count;
	$totalvisits = $start;
	$w1 = max(intval($widthTD * $start / $totalvisits),6);
	$pc1 = number_format($start/$totalvisits*100.,1);
	$str .= "<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td class=\"path\" colspan=\"2\"><div class=\"postit\">search engines, referrers, bookmarks...<br>$start visitors ($pc1 %)</div></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td align=\"center\" colspan=\"2\" class=\"path\"><img src=\"Img/arrowD.jpg\" width=\"$w1\" height=\"$heightTD\"></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n";
	// number of visits that stop here
	$length = strlen($path);
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')>0 and SUBSTRING_INDEX(SUBSTRING(path,INSTR(path,'$path')+$length),'|',1)='' $extrasql";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$stop = $row->count;
	// Number of visits that come here 
	$come = $totalvisits;
	$oldid = $id;
} else {
	// First step: how do we get there, and how many people
	$id = $patharray[0];
	$path = "|$id|";
	// Start here
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')=1";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$start = $row->count;
	// Started somewhere else
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')>1";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$elsewhere = $row->count;
	$totalvisits = $start + $elsewhere;
	$w1 = max(intval($widthTD * $start / $totalvisits),6);
	$w2 = max(intval($widthTD * $elsewhere / $totalvisits),6);
	$pc1 = number_format($start/$totalvisits*100.,1);
	$pc2 = number_format($elsewhere/$totalvisits*100.,1);
	$str .= "<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td class=\"path\"><div class=\"postit\">search engines, referrers, bookmarks...<br>$start visitors ($pc1 %)</div></td><td class=\"path\"><div class=\"postit\">Within $site<br>$elsewhere visitors ($pc2 %)</div></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td align=\"center\" class=\"path\"><img src=\"Img/arrowD.jpg\" width=\"$w1\" height=\"$heightTD\"></td><td align=\"center\" class=\"path\"><img src=\"Img/arrowD.jpg\" width=\"$w2\" height=\"$heightTD\"></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n";
	// number of visits that stop here
	$length = strlen($path);
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')>0 and SUBSTRING_INDEX(SUBSTRING(path,INSTR(path,'$path')+$length),'|',1)='' $extrasql";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$stop = $row->count;
	// Number of visits that come here 
	$come = $totalvisits;
	$oldid = $id;
}
while ($id = next($patharray)) {
	$h1 = max(intval($heightLR * $stop / $totalvisits),6);
	$pc1 = number_format($stop/$totalvisits*100.,1);
	$str .= "<tr><td class=\"path\"><div class=\"postit\">End of visit<br>$stop visitors ($pc1 %)</div></td><td valign=\"middle\" align=\"right\" class=\"path\"><img src=\"Img/arrowL.jpg\" width=\"$widthLR\" height=\"$h1\"></td>";
	$pagename = shortenPage(pagename($c, $table, $oldid));
	$pc1 = number_format($come/$totalvisits*100.,1);
	$str .= "<td class=\"path\" colspan=\"2\"><div class=\"postit\">$pagename<br> $come visitors ($pc1 %)</div></td>";
	$comeold = $come;
	$path = "${path}$id|";
	// Number of visits that make it to the next step
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')>0 $extrasql";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$come = $row->count;
	// Number of visits that went somewhere else
	$elsewhere = $comeold - $stop - $come;
	$h2 = max(intval($heightLR * $elsewhere / $totalvisits),6);
	$pc1 = number_format($elsewhere/$totalvisits*100.,1);
	$str .= "<td valign=\"middle\" align=\"left\" class=\"path\"><img src=\"Img/arrowR.jpg\" width=\"$widthLR\" height=\"$h2\"></td><td class=\"path\"><div class=\"postit\">Somewhere else on $site<br>$elsewhere visitors ($pc1 %)</div></td></tr>\n";
	// number of visits that stop here
	$length = strlen($path);
	$sql = "SELECT SUM(count) as count FROM ${table}_path WHERE INSTR(path,'$path')>0 and SUBSTRING_INDEX(SUBSTRING(path,INSTR(path,'$path')+$length),'|',1)='' $extrasql";
	$res = mysql_query($sql,$c);
	$row = mysql_fetch_object($res);
	$stop = $row->count;
	//
	$w1 = max(intval($widthTD * $come / $totalvisits),6);
	$str .= "<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td align=\"center\" class=\"path\"  colspan=\"2\"><img src=\"Img/arrowD.jpg\" width=\"$w1\" height=\"$heightTD\"></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n";
	$oldid = $id;
}
// GOT TO DO THE END OF THE PATH...
$pagename = shortenPage(pagename($c, $table, $oldid));
$pc1 = number_format($come/$totalvisits*100.,1);
$str .= "<tr><td class=\"path\" colspan=\"2\">&nbsp;</td><td  colspan=\"2\" class=\"path\"><div class=\"postit\">$pagename<br>$come visitors ($pc1 %)</div></td><td class=\"path\" colspan=\"2\">&nbsp;</td></tr>\n<tr>";
$comeold = $come;
$elsewhere = $comeold - $stop;
$w1 = max(intval($widthTD * $stop / $totalvisits),6);
$w2 = max(intval($widthTD * $elsewhere / $totalvisits),6);
$pc1 = number_format($stop/$totalvisits*100.,1);
$pc2 = number_format($elsewhere/$totalvisits*100.,1);
$str .= "<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td align=\"center\" class=\"path\"><img src=\"Img/arrowD.jpg\" width=\"$w1\" height=\"$heightTD\"></td><td align=\"center\" class=\"path\"><img src=\"Img/arrowD.jpg\" width=\"$w2\" height=\"$heightTD\"></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"path\">&nbsp;</td><td class=\"path\"><div class=\"postit\">End of visit<br>$stop visitors ($pc1 %)</div></td><td class=\"path\"><div class=\"postit\">Stay on $site<br>$elsewhere visitors ($pc2 %)</div></td><td colspan=\"2\" class=\"path\">&nbsp;</td></tr>\n";
//
$str .= "</table>\n";
echo $str;
@mysql_close ($c);
}

/***********************************************************************
/* Function mainPath
/* Role: main portal to path analysis
/* Parameters:
/*   - $table
/*   - $site
/*   - $sid
/* Output:
/*   - Echos whatever it finds
/* Created: 02/2006
************************************************************************/
function mainPath($table, $domain, $sid) {
global $server, $user, $password, $base;

$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");

$str = "<table class=\"stat\">\n<tr><td colspan=\"2\" class=\"title\">Visitor behavior</td></tr>\n<tr><td colspan=\"2\" class=\"caption\">Main information</td></tr>\n";
$sql = "SELECT SUM(count) as count, COUNT(id) as diff FROM ${table}_path";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$totalpath = $row->diff;
$totalvisits = $row->count;
$av = 0.0;
if ($totalpath>0) $av = number_format($totalvisits/$totalpath,1);
$str .= "<tr><td>Number of visits analysed</td><td>$totalvisits</td></tr>\n";
$str .= "<tr><td>Number of path</td><td>$totalpath</td></tr>\n";
$str .= "<tr><td colspan=\"2\">In average, each individual path has been followed by $av visitors.</td></tr>\n";
$sql = "SELECT AVG(length) as av FROM ${table}_path";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$av = number_format($row->av,1);
$str .= "<tr><td colspan=\"2\">In average, a path involves $av hits.</td></tr>\n";
$sql = "SELECT count, length FROM ${table}_path ORDER BY length DESC LIMIT 0,1";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$maxlength = $row->length;
$maxlengthcount = $row->count;
$times = "time";
if ($maxlengthcount > 1) $times .= "s";
$hits = "hit";
if ($maxlength > 1) $hits .= "s";
$str .= "<tr><td colspan=\"2\">Longest path has $maxlength $hits and was used $maxlengthcount $times.</td></tr>\n";
$sql = "SELECT count, length FROM ${table}_path ORDER BY count DESC LIMIT 0,1";
$res = mysql_query($sql,$c);
$row = mysql_fetch_object($res);
$maxused = $row->length;
$maxusedcount = $row->count;
$times = "time";
if ($maxusedcount > 1) $times .= "s";
$hits = "hit";
if ($maxused > 1) $hits .= "s";
$str .= "<tr><td colspan=\"2\">Most common path has $maxused $hits and was used $maxusedcount $times.</td></tr>\n";
$str .= "</table>\n";
echo $str;

$str = "<div align=\"center\"><form name=\"hitselect\" action=\"./index.php?mode=stats&sid=$sid&show=commonpath\" method=\"post\"><table class=\"form\"><tr><td>Show common path with more than</td><td><select name=\"nhits\"><option value=\"1\">1</option><option value=\"3\" selected>3</option><option value=\"5\">5</option><option value=\"10\">10</option><option value=\"20\">20</option></select></td><td>hits</td><td width=\"50px\" align=\"center\"><input type=\"submit\" value=\"go\"></td></tr></table></form></div>\n";
echo $str;

echo formnavpages($c,$table, "none", "./index.php?mode=stats&sid=$sid&show=pathdesign", "Show path going through", false);
@mysql_close ($c);

$str = "<table class=\"stat\"><tr><td class=\"title\">Related information</td></tr>
<tr><td>
<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=entryexit\">Entry and exit pages</a>
<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=key\">Keywords and search engines used to access this site</a>
<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=hits&amp;start=1&amp;pageid=all\">Referrers pointing to this site</a>
<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=duration\">Visit duration analysis</a>
<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=retention\">Visitor retention analysis</a></td></tr>
</table>\n";
echo $str;
}

/***********************************************************************
/* Function commonPath
/* Role: show common path with more than a given number of hits
/* Parameters:
/*   - $table
/*   - $site
/*   - $sid
/*   - $nhits
/* Output:
/*   - Echos whatever it finds
/* Created: 02/2006
************************************************************************/
function commonPath($table, $domain, $sid, $nhits) {
global $server, $user, $password, $base;

$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");

$hits = "hit";
if ($nhits>1) $hits .= "s";
$str = "<table class=\"stat\">\n<tr><td class=\"title\">Common path with more than $nhits $hits</td></tr>";
$sql = "SELECT path,count FROM ${table}_path WHERE length>=$nhits ORDER BY count desc limit 0,5";
$res = mysql_query($sql,$c);
while($row = mysql_fetch_object($res)) {
	$path = $row->path;
	$count = $row->count;
	$patharray = explode("|",$path);
	array_shift($patharray);
	array_pop($patharray);
	$visitors = "visitor";
	if ($count>1) $visitors .= "s";
	$str .= "<tr><td class=\"caption\">Path used by $count $visitors</td></tr>\n";
	$str .= "<tr><td>";
	$old = 0;
	$ntmp = 0;
	foreach ($patharray as $page) {
		if ($old != $page) {
			if ($old != 0) {
				$textn = "";
				if ($ntmp>1) $textn = " ($ntmp hits)" ;
				$pagename = shortenPage(pagename($c,$table,$old));
				$link = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$page\" class=\"basic\">Center here</a>";
				$str .= "<div class=\"postitnormal\">$pagename$textn<br><div align=\"center\">$link</div></div>";
			}
			$ntmp = 0;
			$old = $page;
		} 
		$ntmp += 1;
	}
	$textn = "";
	if ($ntmp>1) $textn = " ($ntmp hits)" ;
	$pagename = shortenPage(pagename($c,$table,$old));
	$link = "<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=pathdesign&amp;pageid=$page\" class=\"basic\">Center here</a>";
	$str .= "<div class=\"postitnormal\">$pagename$textn<br><div align=\"center\">$link</div></div>";
	$str .= "\n";
	$pageid = "0|".implode("|", $patharray);
	$str .= "<div class=\"clearer\">&nbsp;</div><div align=\"right\"><a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=studypath&amp;pageid=$pageid\" class=\"basic\">Study visitors flow along this path</a></div></td></tr>";
}
$str .= "</table>";
@mysql_close ($c);
echo $str;
}
?>